// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package coffeelog

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// CoffeelogClient is the client API for Coffeelog service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type CoffeelogClient interface {
	// LogDispense adds new dispense for specified user
	LogDispense(ctx context.Context, in *LogDispenseRequest, opts ...grpc.CallOption) (*LogDispenseResponse, error)
	// ListDispenses lists recent dispenses
	ListDispenses(ctx context.Context, in *ListDispensesRequest, opts ...grpc.CallOption) (*ListDispensesResponse, error)
	// GetDispense shows details about a specific dispense
	GetDispense(ctx context.Context, in *GetDispenseRequest, opts ...grpc.CallOption) (*GetDispenseResponse, error)
	// GetFVStats shows how much coffee each FV consumed in the given timeframe
	GetFVStats(ctx context.Context, in *GetFVStatsRequest, opts ...grpc.CallOption) (*GetFVStatsResponse, error)
}

type coffeelogClient struct {
	cc grpc.ClientConnInterface
}

func NewCoffeelogClient(cc grpc.ClientConnInterface) CoffeelogClient {
	return &coffeelogClient{cc}
}

func (c *coffeelogClient) LogDispense(ctx context.Context, in *LogDispenseRequest, opts ...grpc.CallOption) (*LogDispenseResponse, error) {
	out := new(LogDispenseResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.coffeelog.Coffeelog/LogDispense", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *coffeelogClient) ListDispenses(ctx context.Context, in *ListDispensesRequest, opts ...grpc.CallOption) (*ListDispensesResponse, error) {
	out := new(ListDispensesResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.coffeelog.Coffeelog/ListDispenses", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *coffeelogClient) GetDispense(ctx context.Context, in *GetDispenseRequest, opts ...grpc.CallOption) (*GetDispenseResponse, error) {
	out := new(GetDispenseResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.coffeelog.Coffeelog/GetDispense", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *coffeelogClient) GetFVStats(ctx context.Context, in *GetFVStatsRequest, opts ...grpc.CallOption) (*GetFVStatsResponse, error) {
	out := new(GetFVStatsResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.coffeelog.Coffeelog/GetFVStats", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// CoffeelogServer is the server API for Coffeelog service.
// All implementations must embed UnimplementedCoffeelogServer
// for forward compatibility
type CoffeelogServer interface {
	// LogDispense adds new dispense for specified user
	LogDispense(context.Context, *LogDispenseRequest) (*LogDispenseResponse, error)
	// ListDispenses lists recent dispenses
	ListDispenses(context.Context, *ListDispensesRequest) (*ListDispensesResponse, error)
	// GetDispense shows details about a specific dispense
	GetDispense(context.Context, *GetDispenseRequest) (*GetDispenseResponse, error)
	// GetFVStats shows how much coffee each FV consumed in the given timeframe
	GetFVStats(context.Context, *GetFVStatsRequest) (*GetFVStatsResponse, error)
	mustEmbedUnimplementedCoffeelogServer()
}

// UnimplementedCoffeelogServer must be embedded to have forward compatible implementations.
type UnimplementedCoffeelogServer struct {
}

func (UnimplementedCoffeelogServer) LogDispense(context.Context, *LogDispenseRequest) (*LogDispenseResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method LogDispense not implemented")
}
func (UnimplementedCoffeelogServer) ListDispenses(context.Context, *ListDispensesRequest) (*ListDispensesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListDispenses not implemented")
}
func (UnimplementedCoffeelogServer) GetDispense(context.Context, *GetDispenseRequest) (*GetDispenseResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetDispense not implemented")
}
func (UnimplementedCoffeelogServer) GetFVStats(context.Context, *GetFVStatsRequest) (*GetFVStatsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetFVStats not implemented")
}
func (UnimplementedCoffeelogServer) mustEmbedUnimplementedCoffeelogServer() {}

// UnsafeCoffeelogServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to CoffeelogServer will
// result in compilation errors.
type UnsafeCoffeelogServer interface {
	mustEmbedUnimplementedCoffeelogServer()
}

func RegisterCoffeelogServer(s grpc.ServiceRegistrar, srv CoffeelogServer) {
	s.RegisterService(&Coffeelog_ServiceDesc, srv)
}

func _Coffeelog_LogDispense_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(LogDispenseRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CoffeelogServer).LogDispense(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.coffeelog.Coffeelog/LogDispense",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CoffeelogServer).LogDispense(ctx, req.(*LogDispenseRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Coffeelog_ListDispenses_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListDispensesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CoffeelogServer).ListDispenses(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.coffeelog.Coffeelog/ListDispenses",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CoffeelogServer).ListDispenses(ctx, req.(*ListDispensesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Coffeelog_GetDispense_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetDispenseRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CoffeelogServer).GetDispense(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.coffeelog.Coffeelog/GetDispense",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CoffeelogServer).GetDispense(ctx, req.(*GetDispenseRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Coffeelog_GetFVStats_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetFVStatsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CoffeelogServer).GetFVStats(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.coffeelog.Coffeelog/GetFVStats",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CoffeelogServer).GetFVStats(ctx, req.(*GetFVStatsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Coffeelog_ServiceDesc is the grpc.ServiceDesc for Coffeelog service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Coffeelog_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.vis.coffeelog.Coffeelog",
	HandlerType: (*CoffeelogServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "LogDispense",
			Handler:    _Coffeelog_LogDispense_Handler,
		},
		{
			MethodName: "ListDispenses",
			Handler:    _Coffeelog_ListDispenses_Handler,
		},
		{
			MethodName: "GetDispense",
			Handler:    _Coffeelog_GetDispense_Handler,
		},
		{
			MethodName: "GetFVStats",
			Handler:    _Coffeelog_GetFVStats_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "vseth/vis/coffeelog/coffeelog.proto",
}
